% crop_and_resize.m

%log_filename='crop_and_resize.log.txt';
%fid=fopen(log_filename,'w');
fid=1;

img_size=227;
d=dir;
n_folders=length(d);
%all_sizes=cell(n_folders,1);
for current_folder=1:n_folders
    current_folder_name=d(current_folder).name;
    if (isdir(current_folder_name))
        d_subfolder=dir(current_folder_name);
        n_files=length(d_subfolder);
        fprintf(fid,'%s\t%d\n',current_folder_name,n_files);
        if (n_files>30)
            output_folder=sprintf('cropped%d/%s',img_size,current_folder_name);
            if (~exist(output_folder,'dir'))
                code_exec=sprintf('mkdir %s',output_folder);
                disp(code_exec);
                eval(code_exec);
            end
            %current_sizes=nan*ones(n_files,3);
            for curr_file=1:n_files
                filename=sprintf('%s/%s',current_folder_name,d_subfolder(curr_file).name);
                [filepath,name,ext] = fileparts(filename);
                if (strcmp(ext,'.JPEG'))
                    img=imread(filename);
                    [szx,szy,szz]=size(img);
                    if (szx>szy)
                        img=img(1:szy,:,:);
                    end
                    if (szx<szy)
                        img=img(:,1:szx,:);
                    end
                    if (szz==1)
                        img2(:,:,1)=img;
                        img2(:,:,2)=img;
                        img2(:,:,3)=img;
                        img=img2;
                    end
                    img2=imresize(img,[img_size img_size]);
                    output_filename=sprintf('%s/%s',output_folder,d_subfolder(curr_file).name);
                    imwrite(img2,output_filename,'jpg');
                    clear img img2
                end     % close check on .jpeg extension  
            end         % close curr_file loop
        end             % close check on n_files>30
    end                 % close check on whether folder_name is a dir
end                     % close curr_folder loop
